#!/usr/local/bin/ruby
#

=begin

== prcounter.cgi

prcounter.cgi is a pure Ruby CGI counter.

== version
Ver0.10  2005/03/24  initial version.

== License

Copyright (c) 2005, nosuchperson@ls-al.jp
All rights reserved.

Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

 1. Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer. 

 2. Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution. 

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

=end

=begin
* 
  Ruby ΤߤǤǤ gif Ϣ륫󥿡
  ΥͤȥȡΥͤɽǤ٤ǽϡ  
  ޤ긫ʤ褦ʵǽȤơҤȤĤοʣΥ᡼бդ
  򤷤ɽǤȤ̣ʤΤդƤ롥
  
* 饤֥ʤ
  TAKAHASHI 'Maki' Masayoshi  renlock.rb, gifcat.rb ѤƤޤ

* Ȥ餷
  Ȥꤢ֤Ϥʶ(ե֤ˤSettingsѹɬ)
   public_html / index.html ... 
         +-- count / prcounter.cgi [705]
               |     renlock.rb    [604]
               |     gifcat.rb     [604]
               |     count.dat     [606]
               +-- gif1 [705] / 0.gif .. 9.gif 9_2.gif       [604] 
               +-- gif2 [705] / 0.gif .. 8.gif 8_2.gif 9.gif [604] 
               +-- lock [707] / lock [606]
        
  ץ
    mode    ɽ⡼ɻ(total, today, yesterday, check, dummy)
    count   ǥȤʬ(total)ߡͻ(dummy)
    digits1 Ƿ(total, dummy)
    digits2 Ƿ(today, yesterday)

  ƤӽФ
    * ȡɽ
      http://127.0.0.1/count/prcounter.rb?mode=total
    * ɽ
      http://127.0.0.1/count/prcounter.rb?mode=today
    * ɽ
      http://127.0.0.1/count/prcounter.rb?mode=yesterday
    * åɽ
      http://127.0.0.1/count/prcounter.rb?mode=check
    *  1234567890 Ƿ 10 ǥߡɽ
      http://127.0.0.1/count/prcounter.rb?mode=dummy&count=1234567890&digits1=10

=end



require 'cgi'

# rename lock, gifcat 
require './renlock.rb'
require './gifcat.rb'

version = "PRCounter v0.10"



################################
#          Settings  

# ȡΥɽѥ᡼Υǥ쥯ȥ
gifdir1 = "./gif1"

# ȡΥ󥿤η
digits1 = 6

# Today, Yesterday Υɽѥ᡼Υǥ쥯ȥ
gifdir2 = "./gif2"

# Today, YesterdayΥ󥿤η
digits2 = 3

# ȤΥǡե
countfile = "./count.dat"

# åǥ쥯ȥ
lockdir = "./lock"

# åե
lockfile = "lock"

#          End  
################################

# main class
class GifCounter
  def initialize(gifdir, countfile, lockdir, lockfile)
	@gifdir=gifdir                # gif եΥǥ쥯ȥ
	@countfile=countfile          # 󥿾Υե
	@gifarray = []                # ƿб gif եΥѥ
	@lockdir = lockdir            # åǥ쥯ȥ
	@lockfile = lockfile          # åե
	@newentryflag = false         # ȥե˿ȥɲä롩
  end

  # å
  def printTest(str, test)
	return CGI::escapeHTML(str) + "  <strong>" + (test ? "OK" : "Failed") + "</strong>\n"
  end
  private :printTest

  # å gifonlyflag = false  gif եγǧΤ
  def check(cgi, gifonlyflag = true)
	str = ""
	# gif ե
	flag = FileTest.exist?(@gifdir)
	str+= cgi.li{printTest("gif-dir ( " + @gifdir+" ) exists?", flag)}
	if(flag)
	  flag =  createGifArray
	  str += cgi.li{printTest("gif-files exist?", flag)}
	  if(flag)
		i = 0
		str2 = ""
		@gifarray.each{|arr|
		  str3 = "  files for \'" +  i.to_s + "\': "
		  j = 0
		  arr.each{|file|
			str3 += file
			j+=1
			if (j>0) 
			  str3 += " "
			end
		  }
		  str2 += cgi.li{CGI::escapeHTML(str3) + "\n"}
		  i+=1
		}
		str += cgi.ul{str2}
	  end
	end
	if(!gifonlyflag)
	  return str
	end
	# åط
	lockflag = false
	flag = FileTest.exist?(@lockdir)
	str += cgi.li{printTest("lockdir(" + @lockdir+") exists?", flag)}
	if(flag)
	  flag = FileTest.exist?(@lockdir + '/' + @lockfile)
	  str+=cgi.li{printTest("lockfile(" + @lockdir + '/' + @lockfile+") exists?", flag)}
	  if(flag) 
		lockflag = true
	  end
	end
	# 󥿾ɤǥ󥯥Ȥ̤(եؤϽ񤭽Фʤ)
	flag = FileTest.exist?(@countfile)
	str += cgi.li{printTest("countfile(" + @countfile+") exists?", flag)}
	if(flag)
	  str2 = ""
	  if(lockflag)
		lock = RenLock.new(@lockdir, @lockfile)
		lock.lock()
		readCount()
		str2+=cgi.li{"current count:\n"}
		str2+=cgi.ul{printCount(cgi)}
		incrementCount()
		str2+= cgi.li{"incremented:\n"}
		str2+=cgi.ul{printCount(cgi)}
		lock.unlock()
	  else 
		readCount()
		str2+=cgi.li{"current count:\n"}
		str2+=cgi.ul{printCount(cgi)}
		incrementCount()
		str2+= cgi.li{"incremented:\n"}
		str2+=cgi.ul{printCount(cgi)}
	  end
	  str += cgi.ul{str2}
	end
	return str
  end
  # Ȥɽʥåѡ
  def printCount(cgi)
	str= cgi.li{"  today       = " + @today.to_s+ "\n"}
	str+= cgi.li{"  totalcount  = " + @totalcnt.to_s+ "\n"}
	str+= cgi.li{"  today's cnt = " + @tcnt.to_s+ "\n"}
	str+= cgi.li{"  yesterday's = " + @ycnt.to_s+ "\n"}
	return str
  end
  private :printCount
  # ȥե뤫ǡǿΥǡϥեƬΥեɤ
  def readCount
	infile = File.open(@countfile, "r")
	@alllines = infile.readlines
	infile.close()
	fields = @alllines[0].split("*")
	@today = fields[0].to_i
	@totalcnt = fields[1].to_i
	@tcnt = fields[2].to_i
 	@ycnt = fields[3].to_i

  end
  private :readCount
  # Ȥ򥤥󥯥ȡ 0 ˤХȥåפʤ
  def incrementCount(inc=1)
	t = Time.now
	day = t.day
	if(day!=@today)             # new day
	  @newentryflag = true
	  yday = t - 24*60*60
	  if(yday.day==@today)      # tomorrow
		@ycnt = @tcnt
	  else
		if(day< @today)   # new month
		  @alllines = []
		end
		@ycnt = 0
	  end
	  @tcnt = 0
	end
	@today = day
	@totalcnt+=inc
	@tcnt+=inc
  end
  private :incrementCount
  # Ȥ񤭽Ф
  def writeCount
	outfile = File.open(@countfile, "w")
	nline = @today.to_s + "*" + @totalcnt.to_s+ "*" + @tcnt.to_s+ "*" + @ycnt.to_s+ "*"
	if(@newentryflag)
	  outfile.puts(nline)
	else
	  @alllines[0] = nline
	end
	outfile.puts(@alllines)
	outfile.close()
  end
  private :writeCount
  # ƿб gif ե
  # Ƭο򸫤ƥեбդ
  # ҤȤĤοʣΥե뤬бƤ褤
  # 8.gif, 8_2.gif Ȥä顤ξȤ '8' ɽǻȤ
  # ʥե printGif ȡ 
  def createGifArray
	10.times {|i|
	  @gifarray[i] = []
	}
	dir = Dir.open(@gifdir)
	dir.each{|file|
	  if(file =~ /^(\d).*/)
		dig=$1.to_i
		@gifarray[dig].push(@gifdir + '/' + file);
	  end
	}
	10.times {|i|
	  if(@gifarray[i].size < 1) 
		return false
	  end
	}
	return true
  end
  private :createGifArray
  # Ȥ򥤥󥯥Ȥƥǡ 0 ˤХȥåפʤ
  # inc < 0 ΤȤϥߡȤ -inc 򥫥ͤȤߤʤ
  def countup(inc = 1)
	createGifArray
	if(inc < 0)
	  @totalcnt = -inc
	else
	  lock = RenLock.new(@lockdir, @lockfile)
	  lock.lock()
	  readCount()
	  incrementCount(inc)
	  writeCount()
	  lock.unlock()
	end
  end
  # ɤ߹ޤƤ륫Ȥ gif եνϤ֤
  # digits ϷޥʥǻѤե̾
  # mode : 0  total, 1  today, 2  yesterday Υ
  def printGif(digits=0, mode=0)
	cnt = 0
	textflag = false
	if(digits < 0)
	  textflag = true
	  digits = - digits
	end
	if(mode == 1)        # today's count
	  cnt = @tcnt
	elsif(mode == 2)     # yesterday's count
	  cnt = @ycnt
	else                 # total count
	  cnt = @totalcnt
	end
	if(digits==0)
	  digits = 1
	  base = 1
	  while base < cnt
		digits+=1
		base *= 10
	  end
	else 
	  base = 10**(digits-1)
	end
	cnt %= (base*10)
	files = []
	digits.times{|i|
	  dig = cnt / base
	  cnt %= base
	  base/=10
	  idx = @gifarray[dig].size
	  files[i] = @gifarray[dig][rand(idx)]
	}
	if(textflag)
	  str=""
	  files.each{|file|
		str += file + "\n"
	  }
	  return str
	end
#	files.each{|file|
#	  print file, "\n"
#	}
	gif = GIFCat.new
	gif.read_files(*files)
	return gif.to_gif
  end
end


cgi = CGI.new("html4")
command=cgi['mode']

if(cgi['digits1']!="")
  digits1 = cgi['digits1'].to_i
end
if(cgi['digits2']!="")
  digits2 = cgi['digits2'].to_i
end

if(command=="check")
  gcnt1 = GifCounter.new(gifdir1, countfile, lockdir, lockfile)
  str1 = gcnt1.check(cgi, false)       # check the environment
  gcnt2 = GifCounter.new(gifdir2, countfile, lockdir, lockfile)
  str2 = gcnt2.check(cgi)             # check the environment

  cgi.out {
	cgi.html {
	  cgi.head { 
		cgi.title{"PRCounter"}
	  } +
		cgi.body {
		cgi.h1{version} + 
		cgi.h2{"Check Mode"} +
		  cgi.ul{str1+str2}
	  }
	}
  }
else
  cgi.out("type" => "image/gif") do
	if(command=="today")
	  gcnt = GifCounter.new(gifdir2, countfile, lockdir, lockfile)
	  gcnt.countup(0)     # null countup
	  gcnt.printGif(digits2, 1)
	elsif(command=="yesterday")
	  gcnt = GifCounter.new(gifdir2, countfile, lockdir, lockfile)
	  gcnt.countup(0)     # null countup
	  gcnt.printGif(digits2, 2)
	elsif(command=="dummy")
	  gcnt = GifCounter.new(gifdir1, countfile, lockdir, lockfile)
	  cnt = 1234567890
	  if(cgi['count']!="")
		cnt = cgi['count'].to_i
	  end
	  gcnt.countup(-cnt)     # dummy count
	  gcnt.printGif(digits1, 0)
	else #elsif(command=="total")
	  gcnt = GifCounter.new(gifdir1, countfile, lockdir, lockfile)
	  cnt = 1
	  if(cgi['count']!="")
		cnt = cgi['count'].to_i
	  end
	  gcnt.countup(cnt)     # countup
	  gcnt.printGif(digits1, 0)
	end
  end
end
